# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GenerativefirewallDetectionConfig(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'yara_config': 'GenerativefirewallYaraConfig',
        'ruleset_configs': 'list[GenerativefirewallRulesetConfig]'
    }

    attribute_map = {
        'yara_config': 'yaraConfig',
        'ruleset_configs': 'rulesetConfigs'
    }

    def __init__(self, yara_config=None, ruleset_configs=None):  # noqa: E501
        """GenerativefirewallDetectionConfig - a model defined in Swagger"""  # noqa: E501
        self._yara_config = None
        self._ruleset_configs = None
        self.discriminator = None
        if yara_config is not None:
            self.yara_config = yara_config
        if ruleset_configs is not None:
            self.ruleset_configs = ruleset_configs

    @property
    def yara_config(self):
        """Gets the yara_config of this GenerativefirewallDetectionConfig.  # noqa: E501


        :return: The yara_config of this GenerativefirewallDetectionConfig.  # noqa: E501
        :rtype: GenerativefirewallYaraConfig
        """
        return self._yara_config

    @yara_config.setter
    def yara_config(self, yara_config):
        """Sets the yara_config of this GenerativefirewallDetectionConfig.


        :param yara_config: The yara_config of this GenerativefirewallDetectionConfig.  # noqa: E501
        :type: GenerativefirewallYaraConfig
        """

        self._yara_config = yara_config

    @property
    def ruleset_configs(self):
        """Gets the ruleset_configs of this GenerativefirewallDetectionConfig.  # noqa: E501

        List of configuration settings for individual rulesets.  # noqa: E501

        :return: The ruleset_configs of this GenerativefirewallDetectionConfig.  # noqa: E501
        :rtype: list[GenerativefirewallRulesetConfig]
        """
        return self._ruleset_configs

    @ruleset_configs.setter
    def ruleset_configs(self, ruleset_configs):
        """Sets the ruleset_configs of this GenerativefirewallDetectionConfig.

        List of configuration settings for individual rulesets.  # noqa: E501

        :param ruleset_configs: The ruleset_configs of this GenerativefirewallDetectionConfig.  # noqa: E501
        :type: list[GenerativefirewallRulesetConfig]
        """

        self._ruleset_configs = ruleset_configs

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GenerativefirewallDetectionConfig, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerativefirewallDetectionConfig):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
